;This procedure is intended for use as part of the PCIAS system.  This system
;has been developed by the HAO dPMon project to facilitate the initial
;quality assurance procedures required for new dPMon data.  Please make
;no changes to any of the files in this directory without first contacting
;dPMon personnel.
;
;   Questions regarding PCIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   This module loads the new color table when the user requests a change.
;   It's primary task is to set up the input for the tvlct procedure.
;
pro pcias_colorscale, val
@pcias_common

path =  '/home/cordyn/color_idl/'

case val of
   'B/W LIN' : filename = path + 'bw0.rgb'
   'B/W EXP2' : filename = path + 'bw2.rgb'
   'B/W EXP5' : filename = path + 'bw5.rgb'
   'B/W LG-5' : filename = path + 'bw-5.rgb'
   'B/W LG-20' : filename = path + 'bw-20.rgb'
   'COLOR 1' : filename = path + 'syn_col.rgb'
   'COLOR 2' : filename = path + 'difbrinb.rgb'
endcase

get_lun, lun
openr, lun, filename

_a = intarr(256)
_b = intarr(256)
_c = intarr(256)

readu, lun, _a
readu, lun, _b
readu, lun, _c

close, lun
free_lun, lun

tvlct, _a, _b, _c

return
end
