;This procedure is intended for use as part of the PCIAS system.  This system
;has been developed by the HAO dPmon project to facilitate the initial
;quality assurance procedures required for new dPmon data.  Please make
;no changes to any of the files in this directory without first contacting
;dPmon personnel.
;
;   Questions regarding PCIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   The purpose of this module is to declare all the common blocks used by
;   the PCIAS system.  This module is called by any module that has anything
;   to do with plotting or processing data.  There are no procedure or end
;   statements as this module will be included in procedures via batch file
;   execution.
;

;Debugging block- to be removed for release version.
;common pcias_debug, comm_in

;dpmon disk location/machine information, whether it is puka or puu
common pcias_machine, machine , topdir

;dpmon fits information, whether or not it is an old header...
common pcias_fts, oldheader,fitshdr

;dpmon image size, and display sizes.  And comment length...
common pcias_imagesz, pixx,pixy, scl, xsz,ysz, wxsz,wysz, wxp,wyp, cstrlen,$
 im_array

;Widget identifications, base names listed first.
common pcias_widget, base, col1b, col1c, col1d, col1e, col1eb, col1fb, $
	col2b,$
	col2baa, col2bab, col2bac, col2bb, usr_out1, obsdat, obstim,$
	solrad, nexpos, aptwhl, daysfil, filtwhl, occwhl, hotpix, coldpix,$
	usr_out2, usr_in1 , realexit

;Variables for plotting.
common pcias_plot, plot_index1, pwin_inds, cntr, n_images, time_slide,$
	slide_set, next_intyp, enlarge_win, enlarged, grided, title,$
	grid_image

;Variables for data access and manipulation.
common pcias_data, avail_day, dataday, limb_fnms, lowk_fnms, disk_fnms,$
	flat1_fnms, flat2_fnms, diff1d_fnms, diff2d_fnms, limbd_fnms, $
	diskd_fnms, lowkd_fnms, fnms,$
	datascale, hdrs, info_set, tmarr, gridy

;Variables for user info output.
common pcias_userout, imtyp, totim, curim, hot_pix, cold_pix

;Variables for logfile entries.
common pcias_logfiles, cur_typ, cur_done, lm_comments, ds_comments,$
	lk_comments, f1_comments, f2_comments, fd1_comments, fd2_comments,$
	lmd_comments, dsd_comments, lkd_comments,$
	lm_done, ds_done, lk_done, f1_done, f2_done,fd1_done, fd2_done, $
	lmd_done,$
	dsd_done, lkd_done, nxlog, log_done, comms_done, cur_qual,$
	das_done, de_done, le_done, daily_summ, limb_events, disk_events,$
	summs_done, lm_arch_fnm, ds_arch_fnm, arch_in, cur_summ, lm_qual,$
	ds_qual, lk_qual, f1_qual, f2_qual, fd1_qual, fd2_qual, lmd_qual, $
	dsd_qual, lkd_qual, $
	start_time, stop_time, op_name, wrongtyp  , sav_comm

;Variables for saving and recalling images.
common pcias_save_recall, save1_typ, save2_typ, save3_typ, save1_win,$
	save2_win, save3_win, save1_info, save2_info, save3_info, saved,$
	save1_pix, save2_pix, save3_pix



