;This procedure is intended for use as part of the PCIAS system.  This system
;has been developed by the HAO dPMon project to facilitate the initial
;quality assurance procedures required for new dPMon data.  Please make
;no changes to any of the files in this directory without first contacting
;dPMon personnel.
;
;   Questions regarding PCIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   This module creates a temporary widget to display the information to
;   the user regarding which images have log entries, which archive
;   images have been selected, etc.  This widget is destroyed upon exit.
;
pro pcias_logstatus
@pcias_common

base2 = widget_base(/column, title = 'LOGFILE STATUS')

dm = widget_label(base2, value = 'LIMB IMAGES NEEDING LOG:')
if limb_fnms(0) ne 'n' and (where(lm_done ne 1))(0) ne -1 then begin
   tmp = indgen(n_elements(lm_done))
   tmp = tmp(where(lm_done ne 1))
   lgn = strtrim(tmp,2)
endif else lgn = 'NONE'
lg_stat = widget_text(base2, value = lgn)

dm = widget_label(base2, value = 'DISK IMAGES NEEDING LOG:')
if disk_fnms(0) ne 'n' and (where(ds_done ne 1))(0) ne -1 then begin
   tmp = indgen(n_elements(ds_done))
   tmp = tmp(where(ds_done ne 1))
   lgn = strtrim(tmp,1)
endif else lgn = 'NONE'
lg_stat = widget_text(base2, value = lgn)

dm = widget_label(base2, value = 'LOWK IMAGES NEEDING LOG:')
if lowk_fnms(0) ne 'n' and (where(lk_done ne 1))(0) ne -1 then begin
   tmp = indgen(n_elements(lk_done))
   tmp = tmp(where(lk_done ne 1))
   lgn = strtrim(tmp,1)
endif else lgn = 'NONE'
lg_stat = widget_text(base2, value = lgn)

dm = widget_label(base2, value = 'DIFF1 IMAGES NEEDING LOG:')
if flat1_fnms(0) ne 'n' and (where(f1_done ne 1))(0) ne -1 then begin
   tmp = indgen(n_elements(f1_done))
   tmp = tmp(where(f1_done ne 1))
   lgn = strtrim(tmp,1)
endif else lgn = 'NONE'
lg_stat = widget_text(base2, value = lgn)

dm = widget_label(base2, value = 'DIFF2 IMAGES NEEDING LOG:')
if flat2_fnms(0) ne 'n' and (where(f2_done ne 1))(0) ne -1 then begin
   tmp = indgen(n_elements(f2_done))
   tmp = tmp(where(f2_done ne 1))
   lgn = strtrim(tmp,1)
endif else lgn = 'NONE'
lg_stat = widget_text(base2, value = lgn)

dm = widget_label(base2, value = 'DIFF1 DARK IMAGES NEEDING LOG:')
if diff1d_fnms(0) ne 'n' and (where(fd1_done ne 1))(0) ne -1 then begin
   tmp = indgen(n_elements(fd1_done))
   tmp = tmp(where(fd1_done ne 1))
   lgn = strtrim(tmp,1)
endif else lgn = 'NONE'
lg_stat = widget_text(base2, value = lgn)

dm = widget_label(base2, value = 'DIFF2 DARK IMAGES NEEDING LOG:')
if diff2d_fnms(0) ne 'n' and (where(fd2_done ne 1))(0) ne -1 then begin
   tmp = indgen(n_elements(fd2_done))
   tmp = tmp(where(fd2_done ne 1))
   lgn = strtrim(tmp,1)
endif else lgn = 'NONE'
lg_stat = widget_text(base2, value = lgn)

dm = widget_label(base2, value = 'LIMB DARK IMAGES NEEDING LOG:')
if limbd_fnms(0) ne 'n'  and (where(lmd_done ne 1))(0) ne -1 then begin
   tmp = indgen(n_elements(lmd_done))
   tmp = tmp(where(lmd_done ne 1))
   lgn = strtrim(tmp,1)
endif else lgn = 'NONE'
lg_stat = widget_text(base2, value = lgn)

dm = widget_label(base2, value = 'DISK DARK IMAGES NEEDING LOG:')
if diskd_fnms(0) ne 'n' and (where(dsd_done ne 1))(0) ne -1 then begin
   tmp = indgen(n_elements(dsd_done))
   tmp = tmp(where(dsd_done ne 1))
   lgn = strtrim(tmp,1)
endif else lgn = 'NONE'
lg_stat = widget_text(base2, value = lgn)

dm = widget_label(base2, value = 'LOWK DARK IMAGES NEEDING LOG:')
if lowkd_fnms(0) ne 'n' and (where(lkd_done ne 1))(0) ne -1 then begin
   tmp = indgen(n_elements(lkd_done))
   tmp = tmp(where(lkd_done ne 1))
   lgn = strtrim(tmp,1)
endif else lgn = 'NONE'
lg_stat = widget_text(base2, value = lgn)

if lm_arch_fnm ne ' ' then begin
   lm_ar_str = 'HAS BEEN SELECTED.'
endif else lm_ar_str = 'NEEDS TO BE SELECTED.'

if ds_arch_fnm ne ' ' then begin
   ds_ar_str = 'HAS BEEN SELECTED.'
endif else ds_ar_str = 'NEEDS TO BE SELECTED.'

dm = widget_label(base2, value = ' ')
dm = widget_label(base2, value = 'LIMB ARCHIVE IMAGE ' + lm_ar_str)
dm = widget_label(base2, value = 'DISK ARCHIVE IMAGE ' + ds_ar_str)
dm = widget_label(base2, value = ' ')

if das_done eq 1 then das_str = 'COMPLETE' else das_str = 'INCOMPLETE'
if le_done eq 1 then le_str = 'COMPLETE' else le_str = 'INCOMPLETE'
if de_done eq 1 then de_str = 'COMPLETE' else de_str = 'INCOMPLETE'

dm = widget_label(base2, value = 'DAILY SUMMARY IS ' + das_str)
dm = widget_label(base2, value = 'LIMB EVENT SUMMARY IS ' + le_str)
dm = widget_label(base2, value = 'DISK EVENT SUMMARY IS ' + de_str)

bail = widget_button(base2, value = 'DONE')

widget_control, /realize, base2

ev = widget_event(base2)
widget_control, base2, /destroy

return
end
