;This procedure is intended for use as part of the PCIAS system.  This system
;has been developed by the HAO dPMon project to facilitate the initial
;quality assurance procedures required for new dPMon data.  Please make
;no changes to any of the files in this directory without first contacting
;dPMon personnel.
;
;   Questions regarding PCIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   The purpose of this procedure is to recall the information stored by
;   PCIAS_SAVE when the user pushes any of the save buttons on the logfile
;   control panel.
;
pro pcias_recall, val
@pcias_common

enlarged = 1		;Sets flag so that PCIAS_IMCHANGE will erase screen
			;before continuing with next non-saved image.
case val of
   'RECALL 1' : begin
		   if saved(0) eq 1 then begin
		      widget_control, imtyp, set_value = save1_typ(0)
		      widget_control, curim, set_value = save1_typ(1)
		      widget_control, obsdat, set_value = save1_info(0)
		      widget_control, obstim, set_value = save1_info(1)
		      widget_control, nexpos, set_value = save1_info(2)
		      widget_control, solrad, set_value = save1_info(3)
		      widget_control, aptwhl, set_value = save1_info(4)
		      widget_control, daysfil, set_value = save1_info(5)
		      widget_control, filtwhl, set_value = save1_info(6)
		      widget_control, occwhl, set_value = save1_info(7)
		      widget_control, hotpix, set_value = save1_pix(0)
		      widget_control, coldpix, set_value = save1_pix(1)
		      device, copy = [0, 0, wxsz, wysz, 0, 0, save1_win]

		      if save1_typ(0) ne cur_typ then begin
			 wrongtyp = 1
			 widget_control, col2baa, sensitive = 0
			 widget_control, col2bb, sensitive = 0
			 widget_control, usr_out1, set_value =$
			 'Recalled image not of current type. ' +$
			 'Logfile entry controls temporarily disabled.'
		      endif

		   endif else begin
		      widget_control, usr_out1, set_value =$
		      'No image is currently saved in location 1.'
		   endelse
		end
   'RECALL 2' : begin
		   if saved(1) eq 1 then begin
		      widget_control, imtyp, set_value = save2_typ(0)
		      widget_control, curim, set_value = save2_typ(1)
		      widget_control, obsdat, set_value = save2_info(0)
		      widget_control, obstim, set_value = save2_info(1)
		      widget_control, nexpos, set_value = save2_info(2)
		      widget_control, solrad, set_value = save2_info(3)
		      widget_control, aptwhl, set_value = save2_info(4)
		      widget_control, daysfil, set_value = save2_info(5)
		      widget_control, filtwhl, set_value = save2_info(6)
		      widget_control, occwhl, set_value = save2_info(7)
		      widget_control, hotpix, set_value = save2_pix(0)
		      widget_control, coldpix, set_value = save2_pix(1)
		      device, copy = [0, 0, wxsz, wysz, 0, 0, save2_win]

		      if save2_typ(0) ne cur_typ then begin
			 wrongtyp = 1
			 widget_control, col2baa, sensitive = 0
			 widget_control, col2bb, sensitive = 0
			 widget_control, usr_out1, set_value =$
			 'Recalled image not of current type. ' +$
			 'Logfile entry controls temporarily disabled.'
		      endif

		   endif else begin
		      widget_control, usr_out1, set_value =$
		      'No image is currently saved in location 2.'
		   endelse
		end
   'RECALL 3' : begin
		   if saved(2) eq 1 then begin
		      widget_control, imtyp, set_value = save3_typ(0)
		      widget_control, curim, set_value = save3_typ(1)
		      widget_control, obsdat, set_value = save3_info(0)
		      widget_control, obstim, set_value = save3_info(1)
		      widget_control, nexpos, set_value = save3_info(2)
		      widget_control, solrad, set_value = save3_info(3)
		      widget_control, aptwhl, set_value = save3_info(4)
		      widget_control, daysfil, set_value = save3_info(5)
		      widget_control, filtwhl, set_value = save3_info(6)
		      widget_control, occwhl, set_value = save3_info(7)
		      widget_control, hotpix, set_value = save3_pix(0)
		      widget_control, coldpix, set_value = save3_pix(1)
		      device, copy = [0, 0, wxsz, wysz, 0, 0, save3_win]

		      if save3_typ(0) ne cur_typ then begin
			 wrongtyp = 1
			 widget_control, col2baa, sensitive = 0
			 widget_control, col2bb, sensitive = 0
			 widget_control, usr_out1, set_value =$
			 'Recalled image not of current type. ' +$
			 'Logfile entry controls temporarily disabled.'
		      endif

		   endif else begin
		      widget_control, usr_out1, set_value =$
		      'No image is currently saved in location 3.'
		   endelse
		end
endcase

return
end
