;This procedure is intended for use as part of the PCIAS system.  This system
;has been developed by the HAO dPMon project to facilitate the initial
;quality assurance procedures required for new dPMon data.  Please make
;no changes to any of the files in this directory without first contacting
;dPMon personnel.
;
;   Questions regarding PIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   This is pcias_startup.pro.  This procedure controls the entry and exit
;   from the PCIAS system after IDL has been started by the pcias script.
;
print, ' '
print, ' '
print, ' '
print, '   Restoring compiled procedures...'
restore, 'pcias_compiled.dat'

pcias_setup			;Call to procedure to initialize various
				;processing parameters.
@pcias_common			;Declare all common blocks.
!quiet = 1

daily_summ  = ' '

disk_events = ' '

;Get operator name, for use in writing the log file later.
print, ' '
print, ' '
op_name = ' '
read, '   Enter operator name ==> ', op_name
print, ' '

; Determine machine and thense the directory to use.
spawn, 'uname -n', machine
topdir = '/odo/d/pics/'
;topdir = '/puka/d/cordyn/Data/dPmon/'
;topdir = '/orwell/e/cordyn/Data/dPmon/'

;if      ( machine(0) eq 'puka' )then topdir = '/puka/d/cordyn/Data/dPmon/'  $ 
;else if ( machine(0) eq 'puu'  )then topdir = '/puu/f/cordyn/'  $   
;else print,'Machine unrecognized, puka will be used as the default.'

;Create string array of data directory names from default data directory.
;spawn, '(cd ' + topdir + '; ls -l)', direc_list
;direc_str1 = direc_list(where(strmid(direc_list, 54, 1) eq '0'))
;avail_day = strmid(direc_str1, 54, 6)
spawn,'ls -1 '+topdir,direc_list
avail_day = strmid(direc_list, 0, 6)

pcias_dayselect
pcias_filesort

print, ' '
print, '   Creating widgets...'
pcias_wgt_create		;Call to widget creation routine.  Control
				;is then handed to widget manager.
exit				;Leave IDL entirely when user is finished.
