;This procedure is intended for use as part of the PCIAS system.  This system
;has been developed by the HAO dPMon project to facilitate the initial
;quality assurance procedures required for new dPMon data.  Please make
;no changes to any of the files in this directory without first contacting
;dPMon personnel.
;
;   Questions regarding PCIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   This file contains two procedures.  The first, pcias_wgt_event, is the
;   event handler for the widgets interface on which this system is based.
;   The second is pcias_wgt_create, which specifies the appearance of the
;   control panel through which the user operates the PCIAS system.  
;   Changes made in one procedure must be reflected in the other for the
;   system to work as designed.
;
pro pcias_wgt_event, ev
@pcias_common
on_error, 0

;;;;sav_comm = ' '
widget_control, ev.id, get_uvalue = uval	;Extract widget user value.

;Don't get value from value-unreadable widgets.  Check before extracting val.
;    Widgets like: op3a are unreadable.
val_test = strmid(uval, 3, 1)
if val_test ne 'a' and val_test ne 'b' and val_test ne 'c'$
   then widget_control, ev.id, get_value = val

;Widgets are identified specifically with uval.  The following large case
;statement directs input from the current widget event  according to this
;value.

if(uval ne 'op99' and uval ne 'op99b' )then begin ;{
    if(realexit eq 1) then widget_control, usr_out1, set_value =' '
    if(uval ne 'op99a' )then widget_control, col1fb, sensitive = 0
    realexit=0
endif;}

case uval of
   'op1'  : begin
	      pcias_colorscale, 'B/W LG-20'	;Load default colorscale.
	      plot, [0, 0], [0, 0]		;Erase title screen.
	      if val eq 'I / 4n' then datascale = 0 else datascale = 1
	      widget_control, col1b, sensitive = 1
	      widget_control, col1c, sensitive = 0
	      widget_control, col1d, sensitive = 1
	      widget_control, col1e, sensitive = 0
	      widget_control,usr_out1,set_value='Select image type to view.'
	    end
   'op2'  : begin
	      cur_typ = val
	      widget_control, imtyp, set_value = val
	      widget_control, curim, set_value = ' '
	      widget_control, usr_out2, set_value = ' '
	      widget_control, nxlog, set_value = '      0'
	      pcias_load_images, val
	      if strtrim(fnms(0), 2) ne 'n' then begin
		 pcias_parse_hdrs
		 pcias_imchange, 'init'
		 widget_control, col1c,    sensitive = 1 
		 widget_control, col1d,    sensitive = 1
		 widget_control, col1e,    sensitive = 1
		 widget_control, col2b,    sensitive = 1
		;widget_control, col2bac,  sensitive = 1
		 mystr='Optionally comment, and then quality for each image,'$
		 +' limit '+strtrim(string(cstrlen),2)+' characters.'
		 widget_control, usr_out1, set_value = mystr
	      endif
	    end 
   'op3'  : pcias_imchange, val
   'op3a' : pcias_imchange, 'REWD'
   'op3b' : pcias_imchange, 'FFWD'
   'op3s' : begin
	       slide_set = val
	       pcias_imchange, 'OVERRIDE'
	    end
   'op4'  : pcias_colorscale, val
   'op5'  : begin
	      widget_control, col1eb, sensitive = 1
	      pcias_enlarge, 1 , val
	    end
   'op5a' : pcias_enlarge, 2 , val 
   'op5b' : pcias_enlarge, 3 , val
   'op5c' : pcias_enlarge, 4 , val
   'op6'  : pcias_save, val
   'op7'  : pcias_recall, val
   'op10' : begin
	       comm_in = (strmid(val, 0, cstrlen))(0)
	       if(comm_in eq '  G  ' or $
		  comm_in eq '  B  ' or $
		  comm_in eq '  U  ' )then begin ;{
		   case val of
		      '  G  ' : cur_qual = ' Good    '
		      '  B  ' : cur_qual = ' Bad     '
		      '  U  ' : cur_qual = ' Ugly    '
		   endcase
		   widget_control, usr_out2, set_value = cur_qual
		   comm_in = sav_comm
		   print,'Comment in  ',comm_in
		   pcias_logenter, comm_in
		   comm_in = ' '
		   sav_comm = ' '
		endif else if(comms_done eq 1)then begin ;}{
		   pcias_logenter, comm_in
		endif else begin ;}{
	            sav_comm = (strmid(val, 0, cstrlen))(0)
		    print,'Saved comment is: ',sav_comm
		    widget_control, usr_out1, set_value =$
		       'Select quality rating after entering comment.'
		endelse ;}
	    end
   'op11' : begin
		  widget_control, usr_out1, set_value = $
		      'Do not use this button anymore.'
	    end
   'op12' : begin
	       case val of
		  'DS ENTER' : begin
				 g_ix = where(strtrim(cur_summ,2) ne '')
				 if g_ix(0) ne -1 then begin
				    daily_summ = transpose(cur_summ(g_ix))
				 endif else begin
				    daily_summ = strarr(1)
				    daily_summ(0) = 'No entry.'
				 endelse
				 das_done = 1
				 widget_control, usr_out1, set_value =$
				 'Daily summary entered.'
				 wait, 1
			      end
		  'LE ENTER' : begin
				 g_ix = where(strtrim(cur_summ,2) ne '')
				 if g_ix(0) ne -1 then begin
				    limb_events = transpose(cur_summ(g_ix))
				 endif else begin
				    limb_events = strarr(1)
				    limb_events(0) = 'No entry.'
				 endelse
				 le_done = 1
				 widget_control, usr_out1, set_value =$
				 'Limb events summary entered.'
				 wait, 1
			      end
		  'DE ENTER' : begin
				 g_ix = where(strtrim(cur_summ,2) ne '')
				 if g_ix(0) ne -1 then begin
				    disk_events = transpose(cur_summ(g_ix))
				 endif else begin
				    disk_events = strarr(1)
				    disk_events(0) = 'No entry.'
				 endelse
				 de_done = 1
				 widget_control, usr_out1, set_value =$
				 'Disk events summary entered.'
				 wait, 1
			      end
	       endcase
	       cur_summ = ' '
	       if das_done eq 1 and le_done eq 1 and de_done eq 1$
	       then summs_done=1
	       pcias_logenter, ' '
	    end
   'op13' : begin
	       case cur_typ of
		  'LIMB' : begin
			      lm_arch_fnm = limb_fnms(cntr)
			      lm_qual(cntr) = ' ARCHIVE '
			      log_done(0) = 1
			      arch_in = 1
			   end
		  'DISK' : begin
			      ds_arch_fnm = disk_fnms(cntr)
			      ds_qual(cntr) = ' ARCHIVE '
			      log_done(1) = 1
			      arch_in = 1
			   end
	       endcase
	    pcias_logenter, ' '
	    end
   'op14' : begin
	       widget_control, base, sensitive = 0
	       pcias_logstatus
	       widget_control, base, sensitive = 1
	       pcias_imchange, 'REDRAW'
	    end
   'op15' : begin
	       widget_control, col1e, sensitive = 1
	       pcias_grid , cur_typ
	    end
   'op99' : begin
               widget_control, col1fb, sensitive = 1
            end
   'op99a': begin
                widget_control, usr_out1, set_value =$
                      'Cleaning up -- might take a while --then exitting...'
                pcias_writelogs
                widget_control, base, /destroy
            end
   'op99b': begin
                if(realexit eq 1)then begin
                    widget_control, base, /destroy
                endif else begin
                    realexit=1
                    widget_control, usr_out1, set_value =$
                    'If you really want to exit without saving the logs,'+$
                    ' hit clear again.'
                endelse
            end
endcase
end				;End of widget event handler.

;-----------------------------------------------------------------------------
;			Begin widget creation routine.
;-----------------------------------------------------------------------------
pro pcias_wgt_create
@pcias_common

font = '*times*bold*normal*14*'
afont= '*courier*bold*14*'
widget_control, default_font = font

;Create top-level base.
base = widget_base(title = 'Prominence Monitor Image Assessment Software',$
		   /row, event_pro = 'pcias_wgt_event')

col1 = widget_base(base, /column)
col2 = widget_base(base, /column)
col3 = widget_base(base, /column)

;Begin column 1 layout.
;Define left side panels.
col1a = widget_base(col1, /column, frame = 5, ypad = 10, xpad = 25)	
col1b = widget_base(col1, /column, frame = 5, ypad = 10)
col1c = widget_base(col1, /column, frame = 5)
col1d = widget_base(col1, /column, frame = 5, xpad = 20, ypad = 10)
col1e = widget_base(col1, /column, frame = 5)
col1f = widget_base(col1, /column, frame = 5)	;Base for exit button only.

;Begin placing items in base col1a.
dm = widget_label(col1a, value = 'DATA SCALING')
xmenu, ['MIN-MAX','I / 4n'], col1a,  uvalue = ['op1', 'op1'], /exclusive
;xmenu, ['I / 4n', 'MIN-MAX'], col1a,  uvalue = ['op1', 'op1'], /exclusive


;Begin placing items in base col1b.
dm = widget_label(col1b, value = 'IMAGE TYPE')
xmenu, ['LIMB', 'DISK', 'LOWK', 'DIFF1-0.5A','DIFF2-10A', $
	'DIFF1 DARK','DIFF2 DARK','LIMB DARK', 'DISK DARK',$  
	'LOWK DARK' ], col1b, uvalue = replicate('op2', 10)


;Begin placing items it base col1c.
dm = widget_label(col1c, value = 'IMAGE SELECTION')
read_x11_bitmap, 'ffwd', ffwd	;Read in fast-fwd and rewind bitmaps.
read_x11_bitmap, 'rewd', rewd

xmenu, ['PREV', 'NEXT'], col1c, /row, xpad = 25, uvalue = ['op3', 'op3']
col1ca = widget_base(col1c, /row, xpad = 47)  ;Base for ffwd and rewd buttons.
rew = widget_button(col1ca, value = rewd, uvalue = 'op3a')
fwd = widget_button(col1ca, value = ffwd, uvalue = 'op3b')

time_slide=widget_slider(col1c, maximum=1000, uvalue='op3s', /suppress_value)

animate = widget_button(col1c, value = 'ANIMATE', uvalue = 'op3')


;Begin placing buttons in base col1d.
dm = widget_label(col1d, value = 'COLOR TABLE')
col1da = widget_base(col1d, /column, xpad = 33, /exclusive)
linbw = widget_button(col1da, value = 'B/W LIN', uvalue = 'op4')
exp1bw = widget_button(col1da, value = 'B/W EXP2', uvalue = 'op4')
exp2bw = widget_button(col1da, value = 'B/W EXP5', uvalue = 'op4')
log1bw = widget_button(col1da, value = 'B/W LG-5', uvalue = 'op4')
log2bw = widget_button(col1da, value = 'B/W LG-20', uvalue = 'op4')
colr1 = widget_button(col1da, value = 'COLOR 1', uvalue = 'op4')
colr2 = widget_button(col1da, value = 'COLOR 2', uvalue = 'op4')

widget_control, log2bw, set_button = 1		;Initially, set log -20 b/w.


;Begin placing items in base col1e.
grid    = widget_button(col1e, value = 'GRID',    uvalue = 'op15')
;Commented out by Tony
;enlarge = widget_button(col1e, value = 'ENLARGE', uvalue = 'op5')
;dm      = widget_label (col1e, value = 'IMAGE MOTION')
read_x11_bitmap, 'l_arrow', l_arrow	;Read in arrow bitmaps.
read_x11_bitmap, 'r_arrow', r_arrow
read_x11_bitmap, 'im_cent', im_cent

;Create buttons with arrows in them.
col1eb = widget_base(col1e, /row, xpad = 35)
;lfarr =  widget_button(col1eb, value = l_arrow, uvalue = 'op5a', xsize = 20)
;imcen =  widget_button(col1eb, value = im_cent, uvalue = 'op5b', xsize = 20)
;rtarr =  widget_button(col1eb, value = r_arrow, uvalue = 'op5c', xsize = 20)


; Change by Tony.  Had to move these somewhere else.
;dm     = widget_label (col1f, value = 'EXIT PROGRAM')
;ext    = widget_button(col1f, value = 'EXIT', uvalue = 'op99')
;col1fb = widget_base  (col1f, /row, xpad = 0)
;appnd =  widget_button(col1fb, value = 'APPND', uvalue = 'op99a', xsize = 60)
;clrlg =  widget_button(col1fb, value = 'CLEAR', uvalue = 'op99b', xsize = 60)


;Begin column 2 layout.
col2a = widget_base(col2, /column)	;Base for plotting window.
col2b = widget_base(col2, /column, frame = 5)	;Base for logfile controls.

;main_plot = widget_draw(col2a, xsize = 1024, ysize = 1028, retain = 0)
main_plot = widget_draw(col2a, xsize = 1024, ysize = 1024, retain = 0, $
	x_scroll_size=768, y_scroll_size=768,/scroll)

usr_mes1 = 'Please select the data scaling for the desired image type.'
usr_out1 = widget_text(col2b, xsize = 80, val = usr_mes1, font=afont)

col2ba = widget_base(col2b, /row)

col2baa = widget_base(col2ba, /column, frame = 5) ;Base for g/b/u selection.
dm = widget_label(col2baa, value = 'IMAGE QUALITY')
xmenu,['  G  ','  B  ','  U  '], col2baa, uvalue = replicate('op10', 3),$
	/row, xpad = 8
cont = widget_button(col2baa, value = 'CONTINUE', uvalue = 'op11')
usr_out2 = widget_text(col2ba, xsize = 5, ysize = 1, val = ' ')

col2bab = widget_base(col2ba, /column, frame = 5, ypad = 30)  ;Archive select.
arch_select = widget_button(col2bab, value = 'ARCHIVE', uvalue = 'op13')

col2bac = widget_base(col2ba, /row, frame = 5) ;Base for entry term. butts.
xmenu, ['DS ENTER', 'LE ENTER', 'DE ENTER'], col2bac,$
	uvalue = replicate('op12', 3), /row

; Tony commented these out.  I never use them.
;Row of three bases for save and recall buttons.
col2bad = widget_base(col2ba, /column, ypad = 15)
;save1 = widget_button(col2bad, value = 'SAVE 1', uvalue = 'op6')
;recall1 = widget_button(col2bad, value = 'RECALL 1', uvalue = 'op7')
;col2bae = widget_base(col2ba, /column, ypad = 15)
;save2 = widget_button(col2bae, value = 'SAVE 2', uvalue = 'op6')
;recall2 = widget_button(col2bae, value = 'RECALL 2', uvalue = 'op7')
;col2baf = widget_base(col2ba, /column, ypad = 15)
;save3 = widget_button(col2baf, value = 'SAVE 3', uvalue = 'op6')
;recall3 = widget_button(col2baf, value = 'RECALL 3', uvalue = 'op7')

;status = widget_button(col2ba, value = 'LOG STATUS', uvalue = 'op14')


;Change by Tony.  Delete these to return to original form.
dm     = widget_label (col2bad, value = 'EXIT PROGRAM')
ext    = widget_button(col2bad, value = 'EXIT', uvalue = 'op99')
col1fb = widget_base  (col2bad, /row, xpad = 0)
appnd =  widget_button(col2bad, value = 'APPND', uvalue = 'op99a', xsize = 60)
clrlg =  widget_button(col2bad, value = 'CLEAR', uvalue = 'op99b', xsize = 60)


col2bb = widget_base(col2b, /row, xpad = 50)
dm = widget_label(col2bb, value = 'TEXT INPUT (104): ')
; Change by Tony.  Change xsize to 80 to return to previous size.
usr_in1 = widget_text(col2bb, value = ' ', xsize = 40, uvalue = 'op10',$
		      /editable)


;Begin column 3 layout.
col3a = widget_base(col3, /column, frame = 5) ;Base for user info/stats.
col3b = widget_base(col3, /column, frame = 5) ;Base for image info output.


;Begin placing items in base col3a.
dm = widget_label(col3a, value = 'USER INFO', /frame)
dm = widget_label(col3a, value = 'CURRENT DAY')
curday = widget_text(col3a, value = dataday)
dm = widget_label(col3a, value = 'IMAGE TYPE')
imtyp = widget_text(col3a, value = ' ')
dm = widget_label(col3a, value = 'TOTAL IMS')
totim = widget_text(col3a, value = ' ')
dm = widget_label(col3a, value = 'CURRENT IM')
curim = widget_text(col3a, value = ' ')
dm = widget_label(col3a, value = 'NX FOR LOG')
nxlog = widget_text(col3a, value = '   0')


;Begin placing items in base col3b.
dm = widget_label(col3b, value = 'HEADER INFO', /frame)
dm = widget_label(col3b, value = 'OBS DATE')
obsdat = widget_text(col3b, value = ' ')
dm = widget_label(col3b, value = 'OBS TIME')
obstim = widget_text(col3b, value = ' ')
dm = widget_label(col3b, value = '# EXPOSURES')
nexpos = widget_text(col3b, value = ' ')
dm = widget_label(col3b, value = 'SOLAR RAD')
solrad = widget_text(col3b, value = ' ')
dm = widget_label(col3b, value = 'APERT WHL')
aptwhl = widget_text(col3b, value = ' ')
dm = widget_label(col3b, value = 'DAYSTAR')
daysfil = widget_text(col3b, value = ' ')
dm = widget_label(col3b, value = 'FILT WHL')
filtwhl = widget_text(col3b, value = ' ')
dm = widget_label(col3b, value = 'OCCUL WHL')
occwhl = widget_text(col3b, value = ' ')
dm = widget_label(col3b, value = 'MAX PIXEL')
hotpix= widget_text(col3b, value = ' ')
dm = widget_label(col3b, value = 'MIN PIXEL')
coldpix = widget_text(col3b, value = ' ')

widget_control, /realize, base		;Creatus widgetus.
widget_control, get_value = plot_index1, main_plot	;Get plot destination.

widget_control, col1b,   sensitive = 0
widget_control, col1c,   sensitive = 0
widget_control, col1d,   sensitive = 0
widget_control, col1e,   sensitive = 0
widget_control, col1eb,  sensitive = 0
widget_control, col1fb,  sensitive = 0
widget_control, col2b,   sensitive = 0
widget_control, col2bab, sensitive = 0
widget_control, col2bac, sensitive = 0

pcias_title		;Call routine to put up pretty opening screen.

xmanager, 'pcias_wgt', base		;Hand control to manager.

return
end
